<script lang="ts">
import Vue from 'vue';
import { HorizontalScrollBar } from '../common/index.vue';
import { IsMobileMixin } from '../../mixins';
import SolutionsItem from './solutions-item.vue';

export default Vue.extend({
  components: {
    SolutionsItem,
    HorizontalScrollBar,
  },
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      pageProgress: 8,
      activeIndex: 0,
      progress: 0,
    };
  },
  computed: {
    applyPercent() {
      return this.pageProgress;
    },
  },
  mounted() {
    window.addEventListener('scroll', this.updatePageProgress);
    const { cards } = this.$refs;
    cards.$el.addEventListener('scroll', (e) => {
      const { clientWidth } = e.target;
      const { scrollLeft } = e.target;
      const { scrollWidth } = e.target;

      const scrollPercent = scrollLeft / (scrollWidth - clientWidth);
      const scrollPercentRounded = Math.round(scrollPercent * 100);
      this.progress = scrollPercentRounded;
    });
  },
  destroyed() {
    window.removeEventListener('scroll', this.updatePageProgress);
  },
  methods: {
    getElementDistance(elem: { offsetParent: any; offsetTop: number }) {
      let location = 0;
      if (elem.offsetParent) {
        do {
          location += elem.offsetTop;

          elem = elem.offsetParent;
        } while (elem);
      }
      return location >= 0 ? location : 0;
    },

    updatePageProgress() {
      const elem = document.querySelector('#scroll-solutions');
      const distanceFromTop = this.getElementDistance(elem) - 200;
      const elementHeight = elem?.clientHeight;
      const currentPosition = window.pageYOffset;
      const bottomPosition = distanceFromTop + elementHeight;
      const threshold = 400;
      let activeIndex = 0;

      if (
        distanceFromTop < currentPosition &&
        currentPosition < bottomPosition
      ) {
        const percent =
          ((currentPosition - distanceFromTop) / elementHeight) * 100 + 15;
        if (percent > 100) {
          this.pageProgress = 100;
        } else {
          this.pageProgress = percent;
        }
        activeIndex = Math.ceil(
          (currentPosition - distanceFromTop) / threshold,
        );
        this.activeIndex = activeIndex;
      } else {
        this.activeIndex = 0;
      }
    },
  },
});
</script>

<template>
  <div
    :id="data.id"
    :class="[{ 'white-background': data.white_bg }, 'solutions-block']"
  >
    <SlpContainer class="solutions-block__container">
      <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-96">{{
        data.subtitle
      }}</SlpTypography>

      <div id="scroll-solutions" class="scroll-solutions">
        <SlpColumn :cols="1">
          <div class="progress-container">
            <div
              class="progress-bar"
              :style="{ height: `${pageProgress}%` }"
            ></div>
          </div>
        </SlpColumn>
        <SlpColumn
          ref="cards"
          :cols="11"
          class="scroll-solutions__col slp-align-items-center"
        >
          <SolutionsItem
            v-for="(solution, index) in data.solutions"
            :key="solution.title"
            :item="solution"
            :is-active="index == activeIndex || isMobile"
            :is-mobile="isMobile"
            :animation-type="data.animation_type"
          />
        </SlpColumn>
      </div>
      <HorizontalScrollBar class="horizontal-scroll" :value="progress" />
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss">
.horizontal-scroll {
  display: none;
}

.solutions-block {
  position: relative;

  &__container {
    padding: 96px 96px $spacing-32 96px;
  }

  &.white-background {
    background: #fff;
  }

  img {
    max-width: 100%;
  }

  .scroll-solutions {
    display: flex;
    flex-wrap: wrap;
    position: relative;
    margin-bottom: 96px;
    transition: opacity 0.2s;

    &__col div {
      max-width: 350px;
    }

    &__info:not(:last-child) {
      height: 400px;
    }

    &__info {
      opacity: 0.4;
      transition: opacity 0.2s;
    }

    &__img-col {
      img {
        position: sticky;
        top: 160px;
      }
    }

    &__active-section {
      opacity: 1;
    }
  }

  .progress-container {
    width: 2px;
    background: $color-surface-200;
    position: absolute;
    top: 0;
    bottom: 0;
    left: 0;
  }

  .progress-bar {
    position: absolute;
    background: $color-surface-700;
    width: 2px;
  }

  @media (max-width: $breakpoint-md) {
    h2 {
      margin-bottom: $spacing-48;
      padding-left: $spacing-24;
    }

    &__container {
      padding-left: 0;
      padding-right: 0px;
    }

    .progress-container,
    .progress-bar {
      display: none;
    }

    .scroll-solutions {
      margin-bottom: 0;
    }
  }
}

@media (max-width: 767px) {
  .horizontal-scroll {
    display: block;
    margin-bottom: $spacing-32;
  }

  .scroll-solutions__col {
    display: flex;
    overflow-x: auto;
    scrollbar-width: none;
    -ms-overflow-style: none;
    flex-wrap: nowrap !important;
    padding-left: $spacing-24;
    padding-bottom: 30px;

    &::-webkit-scrollbar {
      // hides scrollbar on browsers that use that use Webkit (Chrome, Safari, Opera, etc)
      width: 0;
      height: 0;
    }
  }
}
</style>
